package  
{
	import flash.events.IEventDispatcher;
	import Action;
	/**
	 * SEC - Simple Event Controller
	 * @author Ilya Shirogorov
	 */
	public class SEC 
	{
		private var _records:Vector.<SECRecord>;
		
		public function SEC() 
		{
			_records = new Vector.<SECRecord>();
		}
		
		/**
		 * Добавляем слушатель
		 * @param	obj
		 * @param	type
		 * @param	listener
		 * @param	useCapture
		 * @param	priority
		 */
		public function add(obj:IEventDispatcher, type:String, listener:Function, useCapture:Boolean = false, priority:int = 0):void {
			var rs:Vector.<SECRecord> = _records
				.filter(Action.create(isObject, obj))
				.filter(Action.create(isType, type))
				.filter(Action.create(isListener, listener))
				.filter(Action.create(isUseCapture, useCapture));
			if (rs.length == 0) {
				_records.push(new SECRecord(obj, type, listener, useCapture));
				obj.addEventListener(type, listener, useCapture, priority, false);
			}
		}
		
		/**
		 * Убираем слушатели
		 * @param	obj - если null, все
		 * @param	type - если null, все obj
		 * @param	listener - если null, все obj, type
		 * @param	useCapture - если неопределён, все obj, type, listener
		 */
		public function remove(obj:IEventDispatcher = null, type:String = null, listener:Function = null, useCapture:* = undefined):void {
			var rs:Vector.<SECRecord> = _records.slice();
			if (obj) {
				rs = rs.filter(Action.create(isObject, obj));
				if (type) {
					rs = rs.filter(Action.create(isType, type));
					if (listener != null) {
						rs = rs.filter(Action.create(isListener, listener));
						if (useCapture is Boolean) {
							rs = rs.filter(Action.create(isUseCapture, useCapture as Boolean));
						}
					}
				}
			}
			for each(var record:SECRecord in rs) {
				_records.splice(_records.indexOf(record), 1);
				record.obj.removeEventListener(record.type, record.listener, record.useCapture);
			}
		}
		
		private function isObject(item:SECRecord, index:int, vector:Vector.<SECRecord>, obj:IEventDispatcher):Boolean {
			return item.obj === obj;
		}
		private function isType(item:SECRecord, index:int, vector:Vector.<SECRecord>, type:String):Boolean {
			return item.type === type;
		}
		private function isListener(item:SECRecord, index:int, vector:Vector.<SECRecord>, listener:Function):Boolean {
			return item.listener === listener;
		}
		private function isUseCapture(item:SECRecord, index:int, vector:Vector.<SECRecord>, useCapture:Boolean):Boolean {
			return item.useCapture === useCapture;
		}

		
	}

}
import flash.events.IEventDispatcher;

class SECRecord {
	public var obj:IEventDispatcher; 
	public var type:String;
	public var listener:Function;
	public var useCapture:Boolean;
	
	public function SECRecord(obj:IEventDispatcher, type:String, listener:Function, useCapture:Boolean) 
	{
		this.obj = obj; 
		this.type = type; 
		this.listener = listener; 
		this.useCapture = useCapture; 
	}
	
}